<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>AUTH_DIAMETER Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249240"></a>AUTH_DIAMETER Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Elena-Ramona</span> <span class="surname">Modroiu</span></h3><div class="affiliation"><span class="orgname">rosdev.ro<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Elena-Ramona</span> <span class="surname">Modroiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2003, 2004 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275490">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248922">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284058">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id284063">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id284089">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249570">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249575">1.3.1. <code class="varname">diameter_client_host</code> (string)</a></span></dt><dt><span class="section"><a href="#id249614">1.3.2. <code class="varname">diameter_client_port</code> (int)</a></span></dt><dt><span class="section"><a href="#id248889">1.3.3. <code class="varname">use_domain</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293406">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293412">1.4.1. 
		<code class="function">diameter_www_authorize(realm)</code>
		</a></span></dt><dt><span class="section"><a href="#id293489">1.4.2. 
		<code class="function">diameter_proxy_authorize(realm)</code>
		</a></span></dt><dt><span class="section"><a href="#id293545">1.4.3. 
		<code class="function">diameter_is_user_in(who, group)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293618">1.5. Installation and Running</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249293">Digest Authentication</a></dt><dt>1.2. <a href="#id249597">Set <code class="varname">diameter_client_host</code> parameter</a></dt><dt>1.3. <a href="#id248872">Set <code class="varname">diameter_client_port</code> parameter</a></dt><dt>1.4. <a href="#id248912">Set <code class="varname">use_domain</code> parameter</a></dt><dt>1.5. <a href="#id293471"><code class="function">diameter_www_authorize</code> usage</a></dt><dt>1.6. <a href="#id293527"><code class="function">diameter_proxy_authorize</code> usage</a></dt><dt>1.7. <a href="#id293599"><code class="function">diameter_is_user_in</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275490"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248922"></a>1.1. Overview</h2></div></div></div><p>
	This module implements SIP authentication and authorization with
	DIAMETER server, namely DIameter Server Client (DISC).
	</p><p>
	NOTE: diameter support was developed for DISC (DIameter Server Client 
	project at http://developer.berlios.de/projects/disc/). This project 
	seems to be no longer maintained and DIAMETER specifications were updated
	in the meantime. Thus, the module is obsolete and needs rework to be 
	usable with opendiameter or other DIAMETER servers.
	</p><p>
	The digest authentication mechanism is presented in next figure.
	</p><div class="example"><a name="id249293"></a><p class="title"><b>Example 1.1. Digest Authentication</b></p><div class="example-contents"><pre class="programlisting">
...
	a) First phase of Digest Authentication for SIP:


     +----+ SIP INVITE   +=====+  DIAMETER      +------+       +------+
     |    | no Auth hdr  #/////#  AA-Request    |      |       |      |
     |    |---------1---&gt;#/////#-------2-------&gt;|      |---2--&gt;|      |
     |UAC |              #UAS//#                |DClnt |       |DSrv  |
     |    |&lt;-----4-------#(SER)#&lt;------3--------|(DISC)|&lt;--3---|(DISC)|
     |    |     401      #/////#  DIAMETER      |      |       |      |
     +----+ Unauthorized +=====+  AA-Answer     +------+       +------+
                                  Result-Code=4001


	b) Second phase of Digest Authentication for SIP:


     +----+ SIP INVITE   +=====+  DIAMETER     +------+       +----+
     |    | Auth hdr     #/////#  AA-Request   |      |       |    |
     |    |--------1----&gt;#/////#-------2------&gt;|      |---2--&gt;|    |
     |UAC |              #UAS//#               |DClnt |       |DSrv|
     |    |&lt;-------4-----#(SER)#&lt;------3-------|      |&lt;--3---|    |
     |    |      200 OK  #/////#  DIAMETER     |      |       |    |
     +----+              +=====+  AA-Answer    +------+       +----+
                                  Result-Code=2001

...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284058"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284063"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>sl</em></span> - used to send stateless replies.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284089"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249570"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249575"></a>1.3.1. <code class="varname">diameter_client_host</code> (string)</h3></div></div></div><p>
		Hostname of the machine where the DIAMETER Client is running.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">localhost</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249597"></a><p class="title"><b>Example 1.2. Set <code class="varname">diameter_client_host</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("auth_diameter", "diameter_client_host", "10.10.10.10")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249614"></a>1.3.2. <code class="varname">diameter_client_port</code> (int)</h3></div></div></div><p>
		Port number where the DIAMETER Client is listening.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">3000</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248872"></a><p class="title"><b>Example 1.3. Set <code class="varname">diameter_client_port</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("auth_diameter", "diameter_client_port", 3000)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248889"></a>1.3.3. <code class="varname">use_domain</code> (int)</h3></div></div></div><p>
		Specifies whether the domain name part of URI is used when checking the
		user's privileges.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">0 (0==false and 1==true )</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248912"></a><p class="title"><b>Example 1.4. Set <code class="varname">use_domain</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("auth_diameter", "use_domain", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293406"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293412"></a>1.4.1. 
		<code class="function">diameter_www_authorize(realm)</code>
		</h3></div></div></div><p>
		SIP Server checks for authorization having a DIAMETER server in backend.
		If no credentials are provided inside the SIP request then a challenge
		is sent back to UAC. If the credentials don't match the ones computed by
		DISC then &#8220;<span class="quote">403 Forbidden</span>&#8221; is sent back.
		</p><p>Negative codes may be interpreted as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>-5 (generic error)</em></span> - some generic error
			occurred and no reply was sent out;
			</p></li><li><p>
			<span class="emphasis"><em>-3 (stale nonce)</em></span> - stale nonce;
			</p></li></ul></div><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>realm</em></span> - the realm to be use for
			authentication and authorization. The string may contain 
			pseudo variables.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293471"></a><p class="title"><b>Example 1.5. <code class="function">diameter_www_authorize</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(!diameter_www_authorize("siphub.net"))
{ /* user is not authorized */
	exit;
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293489"></a>1.4.2. 
		<code class="function">diameter_proxy_authorize(realm)</code>
		</h3></div></div></div><p>
		SIP Proxy checks for authorization having a DIAMETER server in backend.
		If no credentials are provided inside the SIP request then a challenge
		is sent back to UAC. If the credentials don't match the ones computed by
		DISC then &#8220;<span class="quote">403 Forbidden</span>&#8221; is sent back.  For more about 
		the negative return codes, see the above function.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>realm</em></span> - the realm to be use for
			authentication and authorization. The string may contain 
			pseudo variables.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293527"></a><p class="title"><b>Example 1.6. <code class="function">diameter_proxy_authorize</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(!diameter_proxy_authorize("siphub.net"))
{ /* user is not authorized */
	exit;
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293545"></a>1.4.3. 
		<code class="function">diameter_is_user_in(who, group)</code>
		</h3></div></div></div><p>
		The method performs group membership checking with DISC.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>who</em></span> - what header to be used to get the
			SIP URI that is wanted to be checked being member in a certain group.
			It can be: &#8220;<span class="quote">Request-URI</span>&#8221;, &#8220;<span class="quote">From</span>&#8221;,
			&#8220;<span class="quote">To</span>&#8221; or &#8220;<span class="quote">Credentials</span>&#8221;.
			</p></li><li><p><span class="emphasis"><em>group</em></span> - the group name where to check if
			the user is part of.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293599"></a><p class="title"><b>Example 1.7. <code class="function">diameter_is_user_in</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(!diameter_is_user_in("From", "voicemail"))
{ /* user is not authorized */
	exit;
};
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293618"></a>1.5. Installation and Running</h2></div></div></div><p>Notes about installation and running.</p></div></div></div></body></html>
