<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>cachedb_mongodb Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284024"></a>cachedb_mongodb Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id276786">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id270318">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284068">1.2. Advantages</a></span></dt><dt><span class="section"><a href="#id249301">1.3. Limitations</a></span></dt><dt><span class="section"><a href="#id249601">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249606">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249610">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248392">1.5. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248397">1.5.1. <code class="varname">cachedb_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id248447">1.5.2. <code class="varname">op_timeout</code> (int)</a></span></dt><dt><span class="section"><a href="#id293419">1.5.3. <code class="varname">slave_ok</code> (int)</a></span></dt><dt><span class="section"><a href="#id293447">1.5.4. <code class="varname">write_concern</code> (string)</a></span></dt><dt><span class="section"><a href="#id293476">1.5.5. <code class="varname">exec_threshold</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293515">1.6. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293525">1.7. Raw Query Syntax</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248412">Set <code class="varname">cachedb_url</code> parameter</a></dt><dt>1.2. <a href="#id248432">Use MongoDB servers </a></dt><dt>1.3. <a href="#id293403">Set <code class="varname">op_timeout</code> parameter</a></dt><dt>1.4. <a href="#id293432">Set <code class="varname">slave_ok</code> parameter</a></dt><dt>1.5. <a href="#id293460">Set <code class="varname">write_concern</code> parameter</a></dt><dt>1.6. <a href="#id293498">Set <code class="varname">exec_threshold</code> parameter</a></dt><dt>1.7. <a href="#id293538">Mongo Raw Query Syntax</a></dt><dt>1.8. <a href="#id293610">Mongo Raw Query Examples</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id276786"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id270318"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of a cache system designed to work with
		MongoDB servers.
		It uses the Key-Value interface exported from the core.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284068"></a>1.2. Advantages</h2></div></div></div><p>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>memory costs are no longer on the server
				</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>many servers can be used inside a cluster, so the memory
				is virtually unlimited</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>the cache is 100% persistent. A restart
					of OpenSIPS server will not affect the DB. The MongoDB is also
				persistent so it can also be restarted without loss of information.</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>MongoDB is an open-source project so
				it can be used to exchange data
				 with various other applicationsr</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>By creating a MongoDB Cluster, multiple OpenSIPS
				instances can easily share key-value information</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>This module also implements the CacheDB Raw query
				capability, thus you can run whatever query that the MongoDB
				back-end supports, taking full advatange of it.
				</em></span>
			</p></li></ul></div><p>
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249301"></a>1.3. Limitations</h2></div></div></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>
		keys (in key:value pairs) may not contain spaces or control characters
		</em></span>
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249601"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249606"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		None.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249610"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libjson</em></span>
			</p><p>
				The libjson library can be downloaded from: http://oss.metaparadigm.com/json-c/ 
			</p></li><li><p>
				<span class="emphasis"><em>mongo-c-driver</em></span>
			</p><p>
				The mongo C driver can be downloaded from https://github.com/mongodb/mongo-c-driver
				Note : Please use the 0.6 version of the driver
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248392"></a>1.5. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248397"></a>1.5.1. <code class="varname">cachedb_url</code> (string)</h3></div></div></div><p>
			The urls of the server groups that OpenSIPS will connect to in order
			to use the from script cache_store,cache_fetch, etc operations.
			It can be set more than one time.
			The prefix part of the URL will be the identifier that will be used
			from the script.

			If multiple addr:port pairs are passed, the connection is treated 
			as going to a replica set.
		</p><div class="example"><a name="id248412"></a><p class="title"><b>Example 1.1. Set <code class="varname">cachedb_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_mongodb", "cachedb_url","mongodb:instance1://localhost:27017/db.collection")
modparam("cachedb_mongodb", "cachedb_url","mongodb:replicaset1://1.2.3.4:27017,2.3.4.5:27017,3.4.5.6:27017/replicaSetName.db.collection")
...
	</pre></div></div><br class="example-break"><div class="example"><a name="id248432"></a><p class="title"><b>Example 1.2. Use MongoDB servers </b></p><div class="example-contents"><pre class="programlisting">
...
cache_store("mongodb:group1","key","$ru value");
cache_fetch("mongodb:replicaset1","key",$avp(10));
cache_remove("mongodb:cluster1","key");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248447"></a>1.5.2. <code class="varname">op_timeout</code> (int)</h3></div></div></div><p>
			The timeout in ms that will be triggered in case a MongoDB op takes too long.
			Default value is 3000 ( 3 seconds )
		</p><div class="example"><a name="id293403"></a><p class="title"><b>Example 1.3. Set <code class="varname">op_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_mongodb", "op_timeout",5000)
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293419"></a>1.5.3. <code class="varname">slave_ok</code> (int)</h3></div></div></div><p>
			If set to 1, read operations are allowed to go to secondary MongoDB servers
			Default value is 0 ( read and write requests will go to primary nodes = full consistency )
		</p><div class="example"><a name="id293432"></a><p class="title"><b>Example 1.4. Set <code class="varname">slave_ok</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_mongodb", "slave_ok",1);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293447"></a>1.5.4. <code class="varname">write_concern</code> (string)</h3></div></div></div><p>
			The JSON containing the Mongo write concern that should affect all write
			operations. More info can be found at http://docs.mongodb.org/manual/core/write-operations/
		</p><div class="example"><a name="id293460"></a><p class="title"><b>Example 1.5. Set <code class="varname">write_concern</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_mongodb","write_concern","{ \"getLastError\": 1, "j" : "true" }")
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293476"></a>1.5.5. <code class="varname">exec_threshold</code> (int)</h3></div></div></div><p>
			The maximum number of microseconds that a mongodb query can last.
			Anything above the threshold will trigger a warning message to the log
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">0 ( unlimited - no warnings )</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293498"></a><p class="title"><b>Example 1.6. Set <code class="varname">exec_threshold</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_mongodb", "exec_threshold", 100000)
...
	</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293515"></a>1.6. Exported Functions</h2></div></div></div><p>The module does not export functions to be used
		in configuration script.</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293525"></a>1.7. Raw Query Syntax</h2></div></div></div><p>
			The cachedb_mongodb module allows to run RAW queries, thus taking full advantage of the capabilities of the back-end.

			The query syntax is a JSON-based one, very similar to the one that one runs commands in the mongo cli. The query results are also returned as JSON documents, that one can further process in the OpenSIPS script by using the JSON module.
		</p><p>
			The syntax looks like the following :
			</p><div class="example"><a name="id293538"></a><p class="title"><b>Example 1.7. Mongo Raw Query Syntax</b></p><div class="example-contents"><pre class="programlisting">
...
cache_raw_query("mongodb","{ \"op\" : \"desiredOP\", \"ns\" : \"db.collection\", \"query\": {\"_id\" : $rU} }","$avp(mongo_result)");
...
			</pre></div></div><p><br class="example-break">
		</p><p>
			The \"op\" JSON entry specifies the actual operation ( find,update,remove, etc ) that you want to run on the Mongo server and the \"ns\" entry specifies the namespace where you want to run that query. The \"ns\" entry can be missing, and the query will be run on the db.collection that was passed at Connection time in the cachedb_url.
		</p><p>
			The \"query\" entry is the JSON document that specifies the raw query that you want to run.
			The last parameter is an optional AVP parameter, where the JSON documents will be returned ( a find query can return multiple JSON documents, which are correctly populated in the output AVP ). If the query does not return a result, you can ommit the last parameter.
		</p><p>
		The currently suported operations that you can pass in the \"op\" JSON entry are
		</p><div class="itemizedlist"><ul type="disc"><li><span class="emphasis"><em>find - the find operation takes an optional \"fields\" JSON document, specifying the desired fields that should be returned from the mongoDB server.
				</em></span></li><li><span class="emphasis"><em>update - the update operations takes an optional \"match\" JSON document, specifying that only the mongoDB documents that match this JSON will be updated ( similar to the 'where' SQL clause ) . If no \"match\" is provided, all documents will be updated.</em></span></li><li><span class="emphasis"><em>insert</em></span></li><li><span class="emphasis"><em>remove</em></span></li><li><span class="emphasis"><em>count</em></span></li></ul></div><p>
		</p><p>
			Here are a couple examples of running some mongoDB queries :
			</p><div class="example"><a name="id293610"></a><p class="title"><b>Example 1.8. Mongo Raw Query Examples</b></p><div class="example-contents"><pre class="programlisting">
...
/* find documents where my_key has the value 345, and return just the entry1 and entry2 values from the matching documents */
cache_raw_query("mongodb","{ \"op\" : \"find\", \"ns\" : \"my_db.my_col\", \"query\": {\"my_key\" : 345},\"fields\": { \"entry1\" : 1, \"entry2\" : 1 } }","$avp(mongo_result)");

$var(it) = 0;
while ($(avp(mongo_result)[$var(it)]) != NULL) {
	$json(json_res) := $(avp(mongo_result)[$var(it)]);
	xlog("Fetched a new mongo result=$json(json_res). entry1=$json(json_res/entry1) \n");
	$var(it) = $var(it) + 1;
	$json(json_res) = NULL;
}

...
/* insert the {_id: 993, vlad: "opensips",counter: 9000 } document */
cache_raw_query("mongodb","{ \"op\" : \"insert\", \"ns\" : \"some_db.coll\", \"query\": {\"_id\" : 993, \"vlad\" : \"opensips\", \"counter\": 9000} }");
...
/* remove all the documents where "mykey" has the "badvalue" */
cache_raw_query("mongodb","{ \"op\" : \"remove\", \"ns\" : \"db.coll\", \"query\": {\"mykey\" : "badvalue"} }");
...
/* set expired to have the value of 1 in the documents where the counter has the 345 value */
cache_raw_query("mongodb","{ \"op\" : \"update\", \"query\": { \"expired\" : 1}, \"match\" : { \"counter\" : 345 } }");
...
cache_raw_query("mongodb","{ \"op\" : \"count\",\"query\": { \"username\" : $rU} }","$avp(mongo_count_result)");
xlog("We have $avp(mongo_count_result) documents where username = $rU \n");
...
			</pre></div></div><p><br class="example-break">
		</p></div></div></div></body></html>
