<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Call-Center Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248490"></a>Call-Center Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2014 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id276985">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id275098">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id276157">1.2. How it works</a></span></dt><dd><dl><dt><span class="section"><a href="#id284085">1.2.1. DB tables</a></span></dt><dt><span class="section"><a href="#id249290">1.2.2. Call Flows</a></span></dt><dt><span class="section"><a href="#id249621">1.2.3. Agents</a></span></dt></dl></dd><dt><span class="section"><a href="#id248939">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248945">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248964">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id293512">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293517">1.4.1. <code class="varname">db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id293548">1.4.2. <code class="varname">acc_db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id293580">1.4.3. <code class="varname">b2b_scenario</code> (string)</a></span></dt><dt><span class="section"><a href="#id293631">1.4.4. <code class="varname">wrapup_time</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293670">1.5. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293675">1.5.1. 
		<code class="function">cc_handle_call(flowID)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293782">1.6. Exported Statistics</a></span></dt><dd><dl><dt><span class="section"><a href="#id293788">1.6.1. Global statistics</a></span></dt><dt><span class="section"><a href="#id293872">1.6.2. Per-flow statistics (one set for each flow)</a></span></dt><dt><span class="section"><a href="#id293981">1.6.3. Per-agent statistics (one set for each agent)</a></span></dt></dl></dd><dt><span class="section"><a href="#cc_mi_commands">1.7. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id294139">1.7.1. 
		<code class="function">cc_reload</code>
		</a></span></dt><dt><span class="section"><a href="#id294166">1.7.2. 
		<code class="function">cc_agent_login</code>
		</a></span></dt><dt><span class="section"><a href="#id294194">1.7.3. 
		<code class="function">cc_list_queue</code>
		</a></span></dt><dt><span class="section"><a href="#id294223">1.7.4. 
		<code class="function">cc_list_flows</code>
		</a></span></dt><dt><span class="section"><a href="#id294252">1.7.5. 
		<code class="function">cc_list_agents</code>
		</a></span></dt><dt><span class="section"><a href="#id294280">1.7.6. 
		<code class="function">cc_list_calls</code>
		</a></span></dt><dt><span class="section"><a href="#id294308">1.7.7. 
		<code class="function">cc_reset_stats</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id294336">1.8. Exported pseudo-variables</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id295378">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id295382">2.1. Available Functions</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id295344">3. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293532">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.2. <a href="#id293563">Set <code class="varname">acc_db_url</code> parameter</a></dt><dt>1.3. <a href="#id293613">Set <code class="varname">b2b_scenario</code> parameter</a></dt><dt>1.4. <a href="#id293653">Set <code class="varname">wrapup_time</code> parameter</a></dt><dt>1.5. <a href="#id293763"><code class="function">cc_handle_call</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id276985"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id275098"></a>1.1. Overview</h2></div></div></div><p>
	The Call Center module implements an inbound call center system with call 
	flows (for queueing the received calls) and agents (for answering the 
	calls).
	</p><p>
	The module implements the queueing system, the call distribution 
	to agents, agents managements, CDRs for the calls, statistics on 
	call distribution and agent's activity - basically everything 
	except the media playback (for the queue). This part must be provided via 
	a third party media server (FreeSwitch, Asterisk or others).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276157"></a>1.2. How it works</h2></div></div></div><p>
	The main entities in the modules are the flows (queues) and agents.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284085"></a>1.2.1. DB tables</h3></div></div></div><p>
		Each entity has a corresponding table in the database, for 
		provisioning purposes - the <span class="emphasis"><em>cc_flows</em></span> and 
		<span class="emphasis"><em>cc_agents</em></span> tables, see
		<a class="ulink" href="http://www.opensips.org/Documentation/Install-DBSchema-1-11#AEN2361" target="_top">DB schema</a>.
		Data is loaded at startup and cached into memory ; runtime reload is 
		possible via the MI commands (see the <span class="emphasis"><em>cc_reload</em></span> 
		command in <a class="xref" href="#cc_mi_commands" title="1.7. Exported MI Functions">Section 1.7, &#8220;Exported MI Functions&#8221;</a>).
		</p><p>
		Additionally there is a table <span class="emphasis"><em>cc_cdrs</em></span> for writing 
		the CDRs - this operation is done in realtime, after the call in 
		completed, covering all possible cases: call was dropped while in 
		queue, call was rejected by agent, call was accepted by agent, call 
		terminated with error - NOTE that a call may generate more than one 
		CDR (like call rejected by agent A, and redistributed and accepted by 
		agent B).
		</p><p>
		The <span class="emphasis"><em>cc_calls</em></span> table is used to store ongoing calls,
		regardless it's state (in queue, to the agent, ended). It is populated
		at runtime by the module and queried at startup. This table should not
		be manually provisioned.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249290"></a>1.2.2. Call Flows</h3></div></div></div><p>
		A flow is defined by a unique alhanumerical ID - the main attribute 
		of a flow is the <span class="emphasis"><em>skill</em></span> - the skill is a 
		capability required by the flow for an agent to be able to answer the 
		call ; the concept of <span class="emphasis"><em>skills</em></span> is the link between 
		the flows and the agents - telling what agents are serving what flows 
		- the flows require a skill, while the agents provide a set of skills. 
		Agents matching the required skill of a flow will automatically 
		receive calls from that flow.
		</p><p>
		Additional, the flow has a <span class="emphasis"><em>priority</em></span> - as agents 
		may server multiple flows in the same time (based on skills), you can
		define priorities between the flows - if the flows has a higher 
		priority, its calls will be pushed (in deliver to agents and queing) in
		front of the calls from flows with a lower priority.
		</p><p>
		Optionally, the flow may define a <span class="emphasis"><em>prependcid</em></span> - a
		prefix to be added to the CLI (Caller ID) when the call is delivered to
		the agents - as an agent may receive call from multiple flows, it is 
		important for the user to see which was the queue a call was received.
		</p><p>
		In terms of media announcements, the flow defines the 
		<span class="emphasis"><em>message_welcome</em></span> (optional, to be played in the 
		call, before doing anything with the call) and 
		<span class="emphasis"><em>message_queue</em></span> (mandatory, the looping message
		providing infinite on hold media IMPORTANT - this message must cycle 
		and media server must never hung up on it. Both announcements are 
		provided as SIP URIs (where the call has to be sent in order to get
		the playback).
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249621"></a>1.2.3. Agents</h3></div></div></div><p>
		An agent is defined by a unique alhanumerical ID - the main attribute 
		of an agent is its the set of <span class="emphasis"><em>skills</em></span> and its SIP
		<span class="emphasis"><em>location</em></span>. The set of skills will tell what calls
		to be received (from which flows, based on the skill matching); the 
		location is a SIP URI where to call must be sent in order to be 
		answered by the agent.
		</p><p>
		Additionally, the agent has a initial <span class="emphasis"><em>logstate</em></span> - 
		if he is logged in or not (being logged in is a must in order to
		receive calls). The log state may be changed at runtime via a 
		dedicated MI command <span class="emphasis"><em>cc_agent_login</em></span>, see 
		<a class="xref" href="#cc_mi_commands" title="1.7. Exported MI Functions">Section 1.7, &#8220;Exported MI Functions&#8221;</a>.
		</p><p>
		There is a <span class="emphasis"><em>wrapup_time</em></span> defined, saying the 
		time interval for an agent before getting a new call from the system 
		(after he finished a call).
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248939"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248945"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>b2b_logic</em></span> - B2bUA module
			</p></li><li><p>
				<span class="emphasis"><em>database</em></span> - one of the SQL DB modules
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248964"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293512"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293517"></a>1.4.1. <code class="varname">db_url</code> (string)</h3></div></div></div><p>
		SQL address to the DB server -- database specific. This must be
		the Database holding the provisioning tables (cc_flows, cc_agents
		and cc_calls tables).
		</p>
		If not explicitly set, the global OpenSIPS DB URL will be used.
		<p>
		</p><div class="example"><a name="id293532"></a><p class="title"><b>Example 1.1. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("call_center", "db_url", 
	"mysql://opensips:opensipsrw@localhost/opensips")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293548"></a>1.4.2. <code class="varname">acc_db_url</code> (string)</h3></div></div></div><p>
		SQL address to the DB server -- database specific. This must be
		the Database where the CDRs table (cc_cdrs) is located.
		</p>
		If not explicitly set, the global OpenSIPS DB URL will be used.
		<p>
		</p><div class="example"><a name="id293563"></a><p class="title"><b>Example 1.2. Set <code class="varname">acc_db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("call_center", "acc_db_url", 
	"mysql://opensips:opensipsrw@localhost/opensips_cdrs")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293580"></a>1.4.3. <code class="varname">b2b_scenario</code> (string)</h3></div></div></div><p>
		The name of the B2B scenario that is used by the module for handling
		the calls in the queue. This is an advanced options and you should
		not change it unless you really understand what you are doing.
		</p><p>
		The module provides an B2B scenario file 
		<span class="emphasis"><em>scenario_callcenter.xml</em></span> located in the module
		directory. The name of this scenario from this file (which must be
		loaded via the b2b_logic module) must match the 
		<span class="emphasis"><em>b2b_scenario</em></span> parameter.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">call center</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293613"></a><p class="title"><b>Example 1.3. Set <code class="varname">b2b_scenario</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("b2b_logic", "script_scenario", "/etc/opensips/scenario_callcenter.xml")
modparam("call_center", "b2b_scenario", "call center")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293631"></a>1.4.4. <code class="varname">wrapup_time</code> (integer)</h3></div></div></div><p>
		Time for an agent between finishing a call and receiving the next
		call from the system. Even if there are queued calls, the module
		will not deliver call to agent during this wrapup interval.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">30 seconds</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293653"></a><p class="title"><b>Example 1.4. Set <code class="varname">wrapup_time</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("call_center", "wrapup_time", 45)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293670"></a>1.5. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293675"></a>1.5.1. 
		<code class="function">cc_handle_call(flowID)</code>
		</h3></div></div></div><p>
		This must be used only for initial INVITE requests - the function
		pushs the call to be handled by the call center module (via a certain
		flow/queue).
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><p>
		The <span class="bold"><strong>flowID</strong></span> mandatory parameter is
		the ID of the flow to handle this call (push the call to that flow).
		This can be a variable or a static string.
		</p><p>
		The function returns TRUE back to the script if the call was 
		successfully pushed and handled by the Call Center engine. IMPORTANT: 
		you must not do any signaling on the call (reply, relay) after this
		point.
		</p><p>
		In case of error, FALSE is returned to the script with the following 
		return codes:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="bold"><strong>-1</strong></span> - unable to get the flow ID
			from the parameter;
			</p></li><li><p>
			<span class="bold"><strong>-2</strong></span> - unable to parse the FROM URI;
			</p></li><li><p>
			<span class="bold"><strong>-3</strong></span> - flow with FlowID not found;
			</p></li><li><p>
			<span class="bold"><strong>-4</strong></span> - no agents logged in the flow;
			</p></li><li><p>
			<span class="bold"><strong>-5</strong></span> - internal error;
			</p></li></ul></div><div class="example"><a name="id293763"></a><p class="title"><b>Example 1.5. <code class="function">cc_handle_call</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (is_method("INVITE") and !has_totag()) {
	if (!cc_handle_call("tech_support")) {
		send_reply("403","Cannot handle call");
		exit;
	}
}
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293782"></a>1.6. Exported Statistics</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293788"></a>1.6.1. Global statistics</h3></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293793"></a>1.6.1.1. ccg_incalls</h4></div></div></div><p>
			Total number of received calls. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293802"></a>1.6.1.2. ccg_awt</h4></div></div></div><p>
			Global avg. waiting time for calls. (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293812"></a>1.6.1.3. ccg_load</h4></div></div></div><p>
			Global load (across all flows). (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293822"></a>1.6.1.4. ccg_distributed_incalls</h4></div></div></div><p>
			Total number of distributed calls. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293831"></a>1.6.1.5. ccg_answered_incalls</h4></div></div></div><p>
			Total number of calls answered by agents. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293841"></a>1.6.1.6. ccg_abandonned_incalls</h4></div></div></div><p>
			Total number of calls terminated by caller before being
			answered by agents. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293851"></a>1.6.1.7. ccg_onhold_calls</h4></div></div></div><p>
			Total number of calls in the queues (onhold). (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293861"></a>1.6.1.8. ccg_free_agents</h4></div></div></div><p>
			Total number of free agents (across all flows). (realtime type)
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293872"></a>1.6.2. Per-flow statistics (one set for each flow)</h3></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293877"></a>1.6.2.1. ccf_incalls_flowID</h4></div></div></div><p>
			Number of received calls for the flow. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293887"></a>1.6.2.2. ccf_dist_incalls_flowID</h4></div></div></div><p>
			Number of distributed calls in this flow. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293898"></a>1.6.2.3. ccf_answ_incalls_flowID</h4></div></div></div><p>
			Nnumber of calls from the flow answered by agents. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293908"></a>1.6.2.4. ccf_aban_incalls_flowID</h4></div></div></div><p>
			Number of calls (from the flow) terminated by caller before being
			answered by agents. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293919"></a>1.6.2.5. ccf_onhold_incalls_flowID</h4></div></div></div><p>
			Number of calls (from the flow) which were put onhold.
			 (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293929"></a>1.6.2.6. ccf_queued_calls_flowID</h4></div></div></div><p>
			Number of calls which are queued for this flow. (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293939"></a>1.6.2.7. ccf_free_agents_flowID</h4></div></div></div><p>
			Number of free agents serving this flow. (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293950"></a>1.6.2.8. ccf_etw_flowID</h4></div></div></div><p>
			Estimated Time to Wait for this flow. (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293960"></a>1.6.2.9. ccf_awt_flowID</h4></div></div></div><p>
			Avg. Wating Time for this flow. (realtime type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293969"></a>1.6.2.10. ccg_load_flowID</h4></div></div></div><p>
			The load on the flow (number of queued calls versus number of
			logged agents). (realtime type)
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293981"></a>1.6.3. Per-agent statistics (one set for each agent)</h3></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293986"></a>1.6.3.1. cca_dist_incalls_agnetID</h4></div></div></div><p>
			Number of distributed calls to this agent. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293997"></a>1.6.3.2. cca_answ_incalls_agentID</h4></div></div></div><p>
			Nnumber of calls answered by the agent. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id294007"></a>1.6.3.3. cca_aban_incalls_agentID</h4></div></div></div><p>
			Number of calls (sent to this agent) terminated by caller before 
			being answered by agents. (counter type)
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id294018"></a>1.6.3.4. cca_att_agentID</h4></div></div></div><p>
			Avg. Talk Time for this agent (realtime type)
			</p></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="cc_mi_commands"></a>1.7. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294139"></a>1.7.1. 
		<code class="function">cc_reload</code>
		</h3></div></div></div><p>
		Command to reload flows and agents definition from database.
		</p><p>
			It takes no parameter.
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_reload
</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294166"></a>1.7.2. 
		<code class="function">cc_agent_login</code>
		</h3></div></div></div><p>
		Command to login an agent into the Call Center engine.
		</p><p>
		It takes two mandatory parameters, the ID of the agent and the 
		new login state (0 - log off, 1 - log in)
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_agent_login agentX 0
</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294194"></a>1.7.3. 
		<code class="function">cc_list_queue</code>
		</h3></div></div></div><p>
		Command to list all the calls in queuing - for each call, the 
		following attributes will be printed: the flow of the call, for how
		long the call is in the queue, the ETW for the call, call priority 
		and the call skill (inherited from the flow).
		</p><p>
		It takes no parameter.
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_list_queue
</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294223"></a>1.7.4. 
		<code class="function">cc_list_flows</code>
		</h3></div></div></div><p>
		Command to list all the flows - for each flow, the 
		following attributes will be printed: the flow ID, the avg. call 
		duration, how many calls were processed, how many agents are logged, 
		and how many onging calls are.
		</p><p>
		It takes no parameter.
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_list_flows
</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294252"></a>1.7.5. 
		<code class="function">cc_list_agents</code>
		</h3></div></div></div><p>
		Command to list all the agents - for each agent, the 
		following attributes will be printed: agent ID, agent login state and
		agent state (free, wrapup, incall).
		</p><p>
		It takes no parameter.
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_list_agents
</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294280"></a>1.7.6. 
		<code class="function">cc_list_calls</code>
		</h3></div></div></div><p>
		Command to list all the ongoing calls - for each call, the 
		following attributes will be printed: call ID, call state 
		(welcome, queued, toagent, ended), call duration, flow it belongs to,
		agent serving the call (if any).
		</p><p>
		It takes no parameter.
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_list_agents
</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294308"></a>1.7.7. 
		<code class="function">cc_reset_stats</code>
		</h3></div></div></div><p>
		Command to reset all counter-like statistics.
		</p><p>
		It takes no parameter.
		</p><p>
		MI FIFO Command usage:
		</p><pre class="programlisting">
opensipsctl fifo cc_reset_stats
</pre></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id294336"></a>1.8. Exported pseudo-variables</h2></div></div></div><p>
	NONE
	</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id295378"></a>Chapter 2. Developer Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id295382"></a>2.1. Available Functions</h2></div></div></div><p>NONE</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id295344"></a>Chapter 3. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id295348"></a><a name="id295366"></a><p><b>3.1.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id295110"></a><a name="id295452"></a><p><b>3.2.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id295466"></a><a name="id295468"></a><p><b>3.3.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
