<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>maxfwd Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284029"></a>maxfwd Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id280863">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id276065">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249363">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249368">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249059">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248011">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248017">1.3.1. <code class="varname">max_limit</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249606">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249611">1.4.1. 
		<code class="function">mf_process_maxfwd_header(max_value)</code>
		</a></span></dt><dt><span class="section"><a href="#id293411">1.4.2. 
		<code class="function">is_maxfwd_lt(max_value)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249585">Set <code class="varname">max_limit</code> parameter</a></dt><dt>1.2. <a href="#id249703"><code class="function">mx_process_maxfwd_header</code> usage</a></dt><dt>1.3. <a href="#id293500"><code class="function">is_maxfwd_lt</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id280863"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276065"></a>1.1. Overview</h2></div></div></div><p>
		The module implements all the operations regarding MaX-Forward header 
		field, like adding it (if not present) or decrementing and checking 
		the value of the existent one.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249363"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249368"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249059"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248011"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248017"></a>1.3.1. <code class="varname">max_limit</code> (integer)</h3></div></div></div><p>
		Set an upper limit for the max-forward value in the outgoing requests.
		If the header is present, the decremented value is not allowed to 
		exceed this max_limits - if it does, the header value will by 
		decreased to &#8220;<span class="quote">max_limit</span>&#8221;.
		</p><p>Note: This check is done when calling the 
		mf_process_maxfwd_header() header.
		</p><p>
		The range of values stretches from 1 to 256, which is the maximum 
		MAX-FORWARDS value allowed by RFC 3261.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">256</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249585"></a><p class="title"><b>Example 1.1. Set <code class="varname">max_limit</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("maxfwd", "max_limit", 32)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249606"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249611"></a>1.4.1. 
		<code class="function">mf_process_maxfwd_header(max_value)</code>
		</h3></div></div></div><p>
		If no Max-Forward header is present in the received request, a header 
		will be added having the original value equal with 
		&#8220;<span class="quote">max_value</span>&#8221;. If a Max-Forward header is already present,
		its value will be decremented (if not 0).
		</p><p>Retuning codes:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>2 (true)</em></span> - header was not found and
			a new header was succesfully added.
			</p></li><li><p><span class="emphasis"><em>1 (true)</em></span> - header was found and its 
			value was successfully decremented (had a non-0 value).
			</p></li><li><p><span class="emphasis"><em>-1 (false)</em></span> - the header was found and
			its value is 0 (cannot be decremented).
			</p></li><li><p><span class="emphasis"><em>-2 (false)</em></span> - error during processing.
			</p></li></ul></div><p>
		The return code may be extensivly tested via script variable 
		&#8220;<span class="quote">retcode</span>&#8221; (or &#8220;<span class="quote">$?</span>&#8221;).
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>max_value</em></span> - Value to be added if 
			there is no Max-Forwards header field in the message.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id249703"></a><p class="title"><b>Example 1.2. <code class="function">mx_process_maxfwd_header</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# initial sanity checks -- messages with
# max_forwards==0, or excessively long requests
if (!mf_process_maxfwd_header("10") &amp;&amp; $retcode==-1) {
	sl_send_reply("483","Too Many Hops");
	exit;
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293411"></a>1.4.2. 
		<code class="function">is_maxfwd_lt(max_value)</code>
		</h3></div></div></div><p>
		Checks if the Max-Forward header value is less then the 
		&#8220;<span class="quote">max_value</span>&#8221; parameter value. It considers also the value
		of the new inserted header (if locally added).
		</p><p>Retuning codes:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>1 (true)</em></span> - header was found or set and 
			its value is stricly less than &#8220;<span class="quote">max_value</span>&#8221;.
			</p></li><li><p><span class="emphasis"><em>-1 (false)</em></span> - the header was found or 
			set and its value is greater or equal to &#8220;<span class="quote">max_value</span>&#8221;.
			</p></li><li><p><span class="emphasis"><em>-2 (false)</em></span> - header was not found or
			not set.
			</p></li><li><p><span class="emphasis"><em>-3 (false)</em></span> - error during processing.
			</p></li></ul></div><p>
		The return code may be extensivly tested via script variable 
		&#8220;<span class="quote">retcode</span>&#8221; (or &#8220;<span class="quote">$?</span>&#8221;).
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>max_value</em></span> - value to check the 
			Max-Forward.value against (as less than).
			</p></li></ul></div><div class="example"><a name="id293500"></a><p class="title"><b>Example 1.3. <code class="function">is_maxfwd_lt</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# next hope is a gateway, so make no sens to
# forward if MF is 0 (after decrement)
if ( is_maxfwd_lt("1") ) {
	sl_send_reply("483","Too Many Hops");
	exit;
};
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
