<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>sngtc Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>sngtc Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id281938">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id275249">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248007">1.2. How it works</a></span></dt><dt><span class="section"><a href="#id249292">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249297">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249588">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249623">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249628">1.4.1. 
		<code class="function">sngtc_offer()</code>
		</a></span></dt><dt><span class="section"><a href="#id248918">1.4.2. 
		<code class="function">sngtc_callee_answer([listen_if_A[, listen_if_B]])
		</code>
		</a></span></dt><dt><span class="section"><a href="#id293500">1.4.3. 
		<code class="function">sngtc_caller_answer()</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248899"><code class="function">sngtc_offer</code> usage</a></dt><dt>1.2. <a href="#id293483"><code class="function">sngtc_callee_answer</code> usage</a></dt><dt>1.3. <a href="#id293538"><code class="function">sngtc_caller_answer</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id281938"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id275249"></a>1.1. Overview</h2></div></div></div><p>
		The <span class="bold"><strong>Sangoma transcoding module</strong></span> offers the possibility of performing
	voice transcoding with the D-series transcoding cards manufactured by
	Sangoma. The module makes use of the Sangoma Transcoding API in order to 
	manage transcoding sessions on the dedicated equipment. For the cards
	in the network to be detected, the Sangoma SOAP server must be up and
	running (<span class="emphasis"><em>sngtc_server</em></span> daemon).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248007"></a>1.2. How it works</h2></div></div></div><p>
		The module performs several modifications in the SDP body of SIP INVITE,
	200 OK and ACK messages. In all transcoding scenarios, the UAC performs early
	SDP negotiation, while the UAS does late negotiation. This way, OpenSIPS
	becomes responsible for intersecting the codec offer and answer, together with
	the management of transcoding sessions on the Sangoma cards.
	</p><p>
		This scenario brings about a couple of
	<span class="bold"><strong>restrictions</strong></span>:
	</p><div class="itemizedlist"><ul type="disc"><li><p>
				UACs MUST only perform early SDP negotiation
			</p></li><li><p>
				UASs MUST support late SDP negotiation (rfc 3261 requirement)
			</p></li></ul></div><p>
	</p><p>
		Since the <span class="emphasis"><em>sngtc_node</em></span> library performs several memory
	allocations with each newly created transcoding session, the module uses a
	dedicated process, responsible for the management of the above-mentioned sessions. The
	<span class="emphasis"><em>sangoma_worker</em></span> process communicates with the OpenSIPS
	UDP receivers through a series of pipes.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249292"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249297"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>dialog</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249588"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>sngtc_node library</em></span>.
				</p></li><li><p>
				<span class="emphasis"><em>sngtc_server up and running</em></span>.
				</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249623"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249628"></a>1.4.1. 
		<code class="function">sngtc_offer()</code>
		</h3></div></div></div><p>
			The function strips off the SDP offer from a SIP INVITE, thus
		asking for another SDP offer from the opposite endpoint (late negotiation).
		</p><p>

		</p><p>
		The following <span class="bold"><strong>error codes</strong></span> may be returned:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>-1</em></span> - SDP parsing error
			</p></li><li><p><span class="emphasis"><em>-3</em></span> - internal error / no more memory
			</p></li></ul></div><p>
		</p><p>
		The function can be used from REQUEST_ROUTE, ONREPLY_ROUTE.
		</p><div class="example"><a name="id248899"></a><p class="title"><b>Example 1.1. <code class="function">sngtc_offer</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if (is_method("INVITE")) {
		t_newtran();
		create_dialog();
		sngtc_offer();
	}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248918"></a>1.4.2. 
		<code class="function">sngtc_callee_answer([listen_if_A[, listen_if_B]])
		</code>
		</h3></div></div></div><p>
			Handles the SDP offer from 200 OK responses, intersects both offers with
		the capabilities of the transcoding card and creates a new transcoding
		session on the card <span class="bold"><strong>only if</strong></span> necessary. It then rewrites the 200 OK SDP so that it 
		contains the information resulted from the codec intersection.
		</p><p><span class="bold"><strong>Parameters</strong></span> explained:</p><p>
			Since the D-series transcoding cards are connected through either a
		PCI slot or simply an Ethernet connector, they cannot be assigned
		global IPs. Consequently, the module will write the local, private IP of the
		card in the SDP answers sent to each of the endpoints. Since this will not
		work with non-local UAs, the optional parameters force the RTP listen
		interface for each UA. This way, the script writer can enforce a global IP
		for the incoming RTP (which can be port forwarded to a transcoding card).
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>listen_if_A</em></span> - the interface where the UAC (the caller) will send RTP after the call is established (IP from the 'c=' SDP line(s))
			</p></li><li><p><span class="emphasis"><em>listen_if_B</em></span> - the interface where the UAS (the callee) will send RTP after the call is established (IP from the 'c=' SDP line(s))
			</p></li></ul></div><p>
		</p><p>
		The following <span class="bold"><strong>error codes</strong></span> may be returned:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>-1</em></span> - SDP parsing error
			</p></li><li><p><span class="emphasis"><em>-2</em></span> - failed to create transcoding session
			</p></li><li><p><span class="emphasis"><em>-3</em></span> - internal error / no more memory
			</p></li></ul></div><p>
		</p><p>
		This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE.
		</p><div class="example"><a name="id293483"></a><p class="title"><b>Example 1.2. <code class="function">sngtc_callee_answer</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
onreply_route[1] {
	if ($rs == 200)
		sngtc_callee_answer("11.12.13.14", "11.12.13.14");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293500"></a>1.4.3. 
		<code class="function">sngtc_caller_answer()</code>
		</h3></div></div></div><p>
			Attaches an SDP body to the caller's ACK request, so that it matches
		the late SDP negotiation done by the UAS.
		</p><p>
		The following <span class="bold"><strong>error codes</strong></span> may be returned:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>-3</em></span> - internal error / no more memory
			</p></li></ul></div><p>
		</p><p>
		This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE.
		</p><div class="example"><a name="id293538"></a><p class="title"><b>Example 1.3. <code class="function">sngtc_caller_answer</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if (has_totag()) {
		if (loose_route()) {
			...
			if (is_method("ACK"))
				sngtc_caller_answer();
		}
		...
	}
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
