<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>userblacklist Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>userblacklist Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Hardy</span> <span class="surname">Kahl</span></h3><div class="affiliation"><span class="orgname">1&amp;1 Internet AG<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Henning</span> <span class="surname">Westerholt</span></h3><div class="affiliation"><span class="orgname">1&amp;1 Internet AG<br></span></div><code class="email">&lt;<a class="email" href="mailto:henning.westerholt@1und1.de">henning.westerholt@1und1.de</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2008 1&amp;1 Internet AG</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id276604">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id279663">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id274255">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id269891">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249063">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248009">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248014">1.3.1. <code class="varname">db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id249598">1.3.2. <code class="varname">db_table</code> (string)</a></span></dt><dt><span class="section"><a href="#id249640">1.3.3. <code class="varname">use_domain</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249679">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249685">1.4.1. 
		<code class="function">check_user_blacklist (string user, string domain, string number, string table)</code>
	    </a></span></dt><dt><span class="section"><a href="#id293412">1.4.2. 
		<code class="function">check_blacklist (string table)</code>
	    </a></span></dt></dl></dd><dt><span class="section"><a href="#id293447">1.5. <acronym class="acronym">MI</acronym> Commands</a></span></dt><dd><dl><dt><span class="section"><a href="#id293454">1.5.1. 
		<code class="function">reload_blacklist</code>
	    </a></span></dt></dl></dd><dt><span class="section"><a href="#id293487">1.6. Installation and Running</a></span></dt><dd><dl><dt><span class="section"><a href="#id293492">1.6.1. Database setup</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249577">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.2. <a href="#id249624">Set <code class="varname">db_table</code> parameter</a></dt><dt>1.3. <a href="#id249661">Set <code class="varname">use_domain</code> parameter</a></dt><dt>1.4. <a href="#id249707"><code class="function">check_user_blacklist</code> usage</a></dt><dt>1.5. <a href="#id293428"><code class="function">check_blacklist</code> usage</a></dt><dt>1.6. <a href="#id293469"><code class="function">reload_blacklists</code> usage</a></dt><dt>1.7. <a href="#id293516">Example database content - globalblacklist table</a></dt><dt>1.8. <a href="#id293542">Example database content - userblacklist table</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id276604"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id279663"></a>1.1. Overview</h2></div></div></div><p>
	The userblacklist module allows OpenSIPS to handle blacklists
	on a per user basis. This information is stored in a database
	table, which is queried to decide if the number (more exactly,
	the request URI user) is blacklisted or not.
	</p><p>
	An additional functionality that this module provides is the ability
	to handle global blacklists. This lists are loaded on startup into
	memory, thus providing a better performance then in the userblacklist
	case. This global blacklists are useful to only allow calls to certain 
	international destinations, i.e. block all not whitelisted numbers.
	They could also used to prevent the blacklisting of important	
	numbers, as whitelisting is supported too. This is useful for example
	to prevent the customer from blocking emergency call number or service
	hotlines.
	</p><p>
	The module exports two functions, <span class="emphasis"><em>check_blacklist</em></span>
	and <span class="emphasis"><em>check_user_blacklist</em></span> for usage in the config
	file. Furthermore its provide a FIFO function to reload the global
	blacklist cache.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id274255"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id269891"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
			The module depends on the following modules (in the other words 
			the listed modules must be loaded before this module):
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>database</em></span> -- Any database module</p></li></ul></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249063"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
			The following libraries or applications must be installed 
			before running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>none</em></span></p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248009"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248014"></a>1.3.1. <code class="varname">db_url</code> (string)</h3></div></div></div><p>
		Url to the database containing the routing data.
	    </p><p>
		<span class="emphasis"><em>
		Default value is &#8220;<span class="quote">mysql://opensipsro:opensipsro@localhost/opensips</span>&#8221;.
		</em></span>
	    </p><div class="example"><a name="id249577"></a><p class="title"><b>Example 1.1. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("userblacklist", "db_url", "dbdriver://username:password@dbhost/dbname")
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249598"></a>1.3.2. <code class="varname">db_table</code> (string)</h3></div></div></div><p>
		Name of the table where the user blacklist data is stored.
	    </p><p>
		    <span class="emphasis"><em>
			    Default value is &#8220;<span class="quote">userblacklist</span>&#8221;.
		    </em></span>
	    </p><div class="example"><a name="id249624"></a><p class="title"><b>Example 1.2. Set <code class="varname">db_table</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("userblacklist", "db_table", "userblacklist")
...
		    </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249640"></a>1.3.3. <code class="varname">use_domain</code> (integer)</h3></div></div></div><p>
			If set to non-zero value, the domain column in the userblacklist is used.
	    </p><p>
		    <span class="emphasis"><em>
			    Default value is &#8220;<span class="quote">0</span>&#8221;.
		    </em></span>
	    </p><div class="example"><a name="id249661"></a><p class="title"><b>Example 1.3. Set <code class="varname">use_domain</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("userblacklist", "use_domain", 0)
...
		    </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249679"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249685"></a>1.4.1. 
		<code class="function">check_user_blacklist (string user, string domain, string number, string table)</code>
	    </h3></div></div></div><p>
		Finds the longest prefix that matches the request URI user (or the number
		parameter) for the given user and domain name in the database.
		If a match is found and it is not set to whitelist, false is returned.
		Otherwise, true is returned. Pseudo-variables or AVPs can be used for
		the user, domain and number parameters. The number and table variables
		are optional, the defaults are used if they are ommited. The number
		parameter can be used to check for example against the from URI user.
	    </p><div class="example"><a name="id249707"></a><p class="title"><b>Example 1.4. <code class="function">check_user_blacklist</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!check_user_blacklist("user", "domain.com"))
	sl_send_reply("403", "Forbidden");
	exit;
}
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293412"></a>1.4.2. 
		<code class="function">check_blacklist (string table)</code>
	    </h3></div></div></div><p>
		Finds the longest prefix that matches the request URI for the
		given table. If a match is found and it is not set to whitelist,
		false is returned. Otherwise, true is returned.
	    </p><div class="example"><a name="id293428"></a><p class="title"><b>Example 1.5. <code class="function">check_blacklist</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (!check_blacklist("global_blacklist")))
	sl_send_reply("403", "Forbidden");
	exit;
}
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293447"></a>1.5. <acronym class="acronym">MI</acronym> Commands</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293454"></a>1.5.1. 
		<code class="function">reload_blacklist</code>
	    </h3></div></div></div><p>
		Reload the internal global blacklist cache. This is necessary after
		the database tables for the global blacklist have been changed.
	    </p><div class="example"><a name="id293469"></a><p class="title"><b>Example 1.6. <code class="function">reload_blacklists</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
opensipsctl fifo reload_blacklist
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293487"></a>1.6. Installation and Running</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293492"></a>1.6.1. Database setup</h3></div></div></div><p>
			Before running OpenSIPS with userblacklist, you have to setup the database 
			table where the module will read the blacklist data. For that, if 
			the table was not created by the installation script or you choose
			to install everything by yourself you can use the userblacklist-create.sql
			<acronym class="acronym">SQL</acronym> script in the database directories in the 
			opensips/scripts folder as template. 
			Database and table name can be set with module parameters so they 
			can be changed, but the name of the columns must be as they are 
			in the <acronym class="acronym">SQL</acronym> script.
			You can also find the complete database documentation on the
			project webpage, http://www.opensips.org/html/docs/db/db-schema-devel.html.
		</p><div class="example"><a name="id293516"></a><p class="title"><b>Example 1.7. Example database content - globalblacklist table</b></p><div class="example-contents"><pre class="programlisting">
...
+----+-----------+-----------+
| id | prefix    | whitelist |
+----+-----------+-----------+
|  1 |           |         0 |
|  2 | 1         |         1 |
|  3 | 123456    |         0 |
|  4 | 123455787 |         0 |
+----+-----------+-----------+
...
		</pre></div></div><br class="example-break"><p>
		This table will setup a global blacklist for all numbers, only allowing calls
		starting with &#8220;<span class="quote">1</span>&#8221;. Numbers that starting with &#8220;<span class="quote">123456</span>&#8221;
		and &#8220;<span class="quote">123455787</span>&#8221; are also blacklisted, because the longest prefix
		will be matched.
	</p><div class="example"><a name="id293542"></a><p class="title"><b>Example 1.8. Example database content - userblacklist table</b></p><div class="example-contents"><pre class="programlisting">
...
+----+----------------+-------------+-----------+-----------+
| id | username       | domain      | prefix    | whitelist |
+----+----------------+-------------+-----------+-----------+
| 23 | 49721123456788 |             | 1234      |         0 |
| 22 | 49721123456788 |             | 123456788 |         1 |
| 21 | 49721123456789 |             | 12345     |         0 |
| 20 | 494675231      |             | 499034133 |         1 |
| 19 | 494675231      | test        | 499034132 |         0 |
| 18 | 494675453      | test.domain | 49901     |         0 |
| 17 | 494675454      |             | 49900     |         0 |
+----+----------------+-------------+-----------+-----------+
...
		</pre></div></div><br class="example-break"><p>
		This table will setup user specific blacklists for certain usernames. For example
		for user &#8220;<span class="quote">49721123456788</span>&#8221; the prefix &#8220;<span class="quote">1234</span>&#8221; will be not
		allowed, but the number &#8220;<span class="quote">123456788</span>&#8221; is allowed. Additionally a domain
		could be specified that is used for username matching if the &#8220;<span class="quote">use_domain</span>&#8221;
		parameter is set.
	</p></div></div></div></div></body></html>
